//
//  VSViewController.m
//  CollectionViewTest
//
//  Created by Vitaly S. on 5/29/14.
//  Copyright (c) 2014 Test. All rights reserved.
//

#import "VSViewController.h"

#import "VSCollectionViewCell.h"

@interface VSViewController () {
    NSTimer *_timer;
    NSInteger _iterationsBeforeReload;
}

- (void)reloadCollectionView;
- (void)displayInformationLabel;

@end

@implementation VSViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
    
    self.infoLabel1.text = @"Try to click on different cells and then press 'Start test'";
}


- (IBAction)startTest {
    _iterationsBeforeReload = 5;
    [self displayInformationLabel];
    _timer = [NSTimer scheduledTimerWithTimeInterval: 1 target: self selector: @selector(reloadCollectionView) userInfo: nil repeats:YES];
    
}

- (void)displayInformationLabel {
     self.infoLabel1.text = [NSString stringWithFormat: @"Press any collection cell and hold, reload will be called in %ds", _iterationsBeforeReload];
}

- (void)reloadCollectionView {
    if (_iterationsBeforeReload <= 0) {
        [self.collectionView reloadData];
        [_timer invalidate];
        self.infoLabel1.text = @"Release the cell and try to select different cells. The cell you hold can't be selected.";
    }
    else {
        _iterationsBeforeReload--;
        [self displayInformationLabel];
    }
}


- (NSInteger)collectionView:(UICollectionView *)collectionView numberOfItemsInSection:(NSInteger)section {
    return 5;
}

- (UICollectionViewCell*)collectionView:(UICollectionView *)collectionView cellForItemAtIndexPath:(NSIndexPath *)indexPath {
    VSCollectionViewCell *cell = [collectionView dequeueReusableCellWithReuseIdentifier: @"Cell" forIndexPath:indexPath];
    cell.textLabel.text = [NSString stringWithFormat: @"#%d", indexPath.item];
    
    return cell;
}

- (void)collectionView:(UICollectionView *)collectionView didSelectItemAtIndexPath:(NSIndexPath *)indexPath {
    self.infoLabel2.text = [NSString stringWithFormat: @"Selected cell #%d", indexPath.item];
}

@end
